function [y, w, ref] = cICA(X, hr0, threshold, w0, learningRate, mu0, lambda0, gamma, maxIter, OverValue,fitresult,time_trace,ref)
% Constrained ICA for extracting one source signal using the reference signal.
%
% Command:
%   [y, w] = cICA(X, ref, threshold, w0, learningRate, mu0, lambda0, gamma, maxIter, OverValue)??
%
% Parameters:
%            y --- extracted source signal, according to the given optimal time delay.
%            w --- corresponding weight vector, that is, y=w'*X.
%            X --- prewhitened observed mixed signals. Each row is a mixed signal.     
%          ref --- reference signal, which can be generated by function genRectangleRef
%                  and genPulseRef
%    threshold --- the closeness of the desired signal and the reference signal is less than 
%                  or equal to the threshold, i.e., closeness(y,ref) - threshold <= 0
%           w0 --- the initial weight vector
% learningRate --- learning rate of the weight w
%          mu0 --- the Lagrange multiplier for constraint g(w)
%      lambda0 --- the Lagrange multiplier for constraint h(w)
%        gamma --- the scalar penalty parameter
%  OverValue --- stopping criterion, say, 0.0001. When the changed value 
%                of weighted vector is less than it, then the algorithm stops
%    maxIter --- maximum iterations for estimating each independent component
%    fitresult --- Fourier model for ppg 
%    timelimits --- Start and end time for the original signal
% See also:
%    genPulseRef     genRectangleRef     cICAdemo
%
% Reference:
%    [1] Wei Lu, Jagath C. Rajapakse: ICA with reference. ICA 2001
%    [2] Zhi-Lin Zhang, Morphologically Constrained ICA for Extracting Weak Temporally 
%        Correlated Signals, Neurocomputing 71(7-9) (2008) 1669-1679
%
% Author: Zhilin Zhang
%         z4zhang@ucsd.edu
%
% version: 1.0     Date: Dec.14,2008
% 
LOW_F=.3; % low freq for PSD range
UP_F=3; % high freq for PSD range

y=X(2,:);
Fs = 1/mean(diff(time_trace));
[power,freq] = pwelch(y,[],[],length(y)*3,Fs, 'psd');
rangePPG = (freq>LOW_F & freq < UP_F); % frequency range to find PSD peak
power = power(rangePPG);
freq = freq(rangePPG);

plot(freq,power);
fprintf('Starting cICA for extracting the desired source signal ..\n');
[ICnum, IClen]=size(X);
hr=hr0;

w = w0;
oldw = w;

mu1 = mu0;
lambda1 = lambda0;

mu2 = mu0;
lambda2 = lambda0;
penaltyHR=.4;

flag = 1;
loop = 1;

% compute the autocorrelation matrix Rxx
Rxx = X(:,[1:end]) * X(:,[1:end])' / IClen;
%Generate intial ref signal


Fs = 256;
nfft = Fs*60; % nb of points for FFT
window = hanning(nfft);

while (flag == 1)
    
    % output at current iteration
    y = w' * X;       
    
    %Ref signal at the current iteration
    ref=gen_ppg_signal(fitresult,'cardiac_freq',hr/60,'time_trace',time_trace);    
    
    [cr,lags]=xcorr(y,'coeff');
%     figure(7);
%     cla;
%     plot(lags,cr);
%     
    %Offset ref using xcorr
    [y1,ref1]=align_signals(y,ref);
    %ref1 is shifted. May not be of the same length.
    %Find the first trough in ref1, append it to the beginning of ref and
    %adjust the length of ref accordingly
    [pks,loc]=findpeaks(-ref1);
%     if(numel(loc)>0)
%         ref=[ref1(1:loc(1)) ref(1:end-loc(1))];
%     end
%     figure(5);
%     cla;
%     hold on
%     p1=plot(y);
%     p2=plot(ref);
%     legend('y','ref');
%     
  
%    pause(.1);

    hr_y=hr_spectogram(time_trace,y);
    hr_ref=hr_spectogram(time_trace,ref);
    
    % calculate the first order deviation of the Lagarange function
    std_y = std(y);                          % standard deviation
    v_Gaus = normrnd(0, std_y, 1, IClen);    % Gaussian signal with the same mean and variance
    rou = mean( log(cosh(y)) - log(cosh(v_Gaus)) );
    L1 = sign(rou) * ( X * tanh(y)')/IClen -  mu1 * ( X * (y - ref)')/IClen ...
    + mu2 * ( (hr_y-hr_ref))/IClen ...
    - lambda1 * ( X * y')/IClen;  %Eqn 15
    % - lambda2 * ( X * r')/IClen;  
    %Instead of adding an extra parameter, we make sure that the generated 
    %ref signal is zero mean and unit variance in gen_ppg_signal
    
    % related to the second order deviation of the Lagarange function
    Sw = sign(rou) * mean(1-tanh(y).^2) - mu1 - lambda1 - mu2;

    % update of the weight vector
    w = w - learningRate * inv(Rxx) * L1 / Sw;   %Eqn 17
    
    %For ICA
    %hypTan = tanh(a1 * X' * w);
    %w = (X * hypTan - a1 * sum(1 - hypTan .^ 2)' * w) / IClen;
    
%     w = w - learningRate * L1 / Sw;
    w = w/norm(w);
    
    % update of the parameter mu1
    thr = threshold * (1-exp(-loop)); %Exponential increase in the thr value. NOT USED          
    thr = threshold;
    g1 = mean( (y-ref).^2 ) - thr;    % corresponds to the inequality constraint
    mu1 = max(0, mu1 + gamma * g1);   %Eqn 18
    
    %Update mu2
    
    sign_g2=sign(hr_y-hr_ref);
    g2 = abs(hr_y-hr_ref) - thr;
    mu2=max(0, mu2 + sign_g2*penaltyHR * g2);
    
    % update of the parameter lambda1
    h1 = mean(y.^2) - 1;                    % corresponds to the equality constraint
    lambda1 = lambda1 + gamma * h1;                 %Eqn 19
    
    %Update lambda2
    h2 = mean(ref.^2) - 1;
    lambda2 = lambda2 + gamma * h2;
    
    %Update hr of ref
    hr = max(0, hr + sign_g2*penaltyHR * g2)
    % decide whether the algorithm has converged or not
    wchange = 1-abs(w'*oldw);
    fprintf('No.%d iteration: change in w is %g\n',loop, wchange);
    if wchange < OverValue
        fprintf('Converged after %d iteration\n',loop);
        flag = 0;
    end

    if loop >= maxIter
        fprintf('After %d iteration, still cannot convergent.\n',loop);
        flag = 0;
    end

    oldw = w;
    loop = loop + 1;

end

% output
y = w'* X;

fprintf('End of cICA algorithm !\n');
